//+------------------------------------------------------------------+
//|                                                      StD_Lnx.mq4 |
//|                                                                  |
//|                                               Written by Linuxser|   
//|                                       http://www.linuxser.com.ar |                                
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  LimeGreen
#property  indicator_color2  FireBrick
#property  indicator_color3  Tomato
#property  indicator_color4  Gray
//---- indicator parameters
extern int StDper=20;
extern int MODE_StD=0;
extern int Price_StD=0;
extern int Signal=9;
extern int MODE_MA=0;
extern int ArrowStyle= 159;
//---- indicator buffers

double StDBuffer[];
double SignalBuffer[];
double LSDBuffer[];
double StDUpBuffer[];
double StDDownBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"StD");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"Signal");
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,ArrowStyle);
   SetIndexLabel(2,NULL);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,ArrowStyle);
   SetIndexLabel(3,NULL);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexLabel(4,NULL);
   SetIndexDrawBegin(0,Signal);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- 3 indicator buffers mapping

   SetIndexBuffer(0,StDBuffer); 
   SetIndexBuffer(1,SignalBuffer);   
   SetIndexBuffer(2,StDUpBuffer);
   SetIndexBuffer(3,StDDownBuffer);
   SetIndexBuffer(4,LSDBuffer); 
   Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("StD Lnx v1("+StDper+","+Signal+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++){
      StDBuffer[i]=iStdDev(NULL,0,StDper,0,MODE_StD,Price_StD,i);
   }
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++){
      SignalBuffer[i]=iMAOnArray(StDBuffer,Bars,Signal,0,MODE_MA,i);
   }
//---- main loop
   for(i=0; i<limit; i++){
      LSDBuffer[i]=(StDBuffer[i]-SignalBuffer[i]);
      
      if(LSDBuffer[i]>0){
         StDUpBuffer[i]=0;
         StDDownBuffer[i]=EMPTY_VALUE;
      }else if(LSDBuffer[i]<0){
         StDDownBuffer[i]=0;
         StDUpBuffer[i]=EMPTY_VALUE;
      }else{
         StDUpBuffer[i]=0;
         StDDownBuffer[i]=0;
      }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

